VERSION 5.00
Begin VB.UserControl DockingCTL 
   BackColor       =   &H00000080&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ControlContainer=   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "DockingCTL.ctx":0000
End
Attribute VB_Name = "DockingCTL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const GWL_STYLE = (-16)
Private Const GWL_EXSTYLE = (-20)

Private Const WM_SETTEXT = &HC
Private Const WM_MOVING = &H216
Private Const WM_SIZE = &H5
Private Const WM_EXITSIZEMOVE = &H232&


Private Const WM_CAPTURECHANGED = &H215
              
Private Const WM_NCLBUTTONDOWN = &HA1
Private Const HTCAPTION = 2
Private Const HTCLOSE = 20

Private Const WS_CAPTION = &HC00000 '  WS_BORDER Or WS_DLGFRAME
Private Const WS_SYSMENU = &H80000
Private Const WS_THICKFRAME = &H40000
Private Const WS_EX_TOOLWINDOW = &H80

Private Enum ESetWindowPosStyles 'Slimy Windows Hacks'
  SWP_SHOWWINDOW = &H40
  SWP_HIDEWINDOW = &H80
  SWP_FRAMECHANGED = &H20 ' The frame changed: send WM_NCCALCSIZE
  SWP_NOACTIVATE = &H10
  SWP_NOCOPYBITS = &H100
  SWP_NOMOVE = &H2
  SWP_NOOWNERZORDER = &H200 ' Don't do owner Z ordering
  SWP_NOREDRAW = &H8
  SWP_NOREPOSITION = SWP_NOOWNERZORDER
  SWP_NOSIZE = &H1
  SWP_NOZORDER = &H4
  SWP_DRAWFRAME = SWP_FRAMECHANGED
  HWND_NOTOPMOST = -2
End Enum

Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Private Type POINTAPI
  X As Long
  Y As Long
End Type

Private Type tAnchorAt
  AnchorAt As AlignConstants
  NewRect As RECT
  oldAnchor As AlignConstants
End Type


Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Implements ISubclass
' ===========================================================================
'ISubclass
'Copyright  1998-1999, Steve McMahon ( steve@vbaccelerator.com). All Rights Reserved.
'Author: Steve McMahon (steve@vbaccelerator.com)
'www.vbaccelerator.com
' ===========================================================================


Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cX As Long, ByVal cY As Long, ByVal wFlags As Long) As Long


'Default Property Values:
Const m_def_Caption = ""
Const m_def_Sizeable = False
Const m_def_Moveable = False
Const m_def_Dockable = False
'Property Variables:
Dim m_Caption As String
Private m_oldMoveable As Boolean
Private m_oldSizeable As Boolean
Private m_Sizeable As Boolean
Private m_Moveable As Boolean
Private m_Dockable As Boolean
Private m_Subclass As Boolean
Private m_newUCPos As tAnchorAt
Private m_MovingUC As Boolean
Private m_parentHwnd As Long

'Event Declarations:
Event Show()
Event Hide()
Event ParentSize()
'Event NewAnchorMode(ByVal NewAnchor As AlignConstants, ByVal oldAnchor As AlignConstants)
Event StyleChanged(ByVal DockableStyle As Boolean, ByVal MoveableStyle As Boolean, ByVal SizeableStyle As Boolean)
Event CloseButtonClick()
Event ExitSizeMove()

Event HitTest(X As Single, Y As Single, HitResult As Integer) 'MappingInfo=UserControl,UserControl,-1,HitTest
Attribute HitTest.VB_Description = "Occurs in a windowless user control in response to mouse activity."
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyDown
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Event KeyPress(KeyAscii As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyPress
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyUp
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
Event Paint() 'MappingInfo=UserControl,UserControl,-1,Paint
Attribute Paint.VB_Description = "Occurs when any part of a form or PictureBox control is moved, enlarged, or exposed."
Event Resize() 'MappingInfo=UserControl,UserControl,-1,Resize
Attribute Resize.VB_Description = "Occurs when a form is first displayed or the size of an object changes."
Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick




'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Public Property Get Sizeable() As Boolean
  Sizeable = m_Sizeable
End Property

Public Property Let Sizeable(ByVal New_Sizeable As Boolean)
  If Not New_Sizeable Then m_Dockable = False
  
  SetStyles m_Dockable, Me.Moveable, New_Sizeable
'If m_Sizeable <> New_Sizeable Then RaiseEvent NewStyle("Sizeable", New_Sizeable)
  m_Sizeable = New_Sizeable
  PropertyChanged "Sizeable"
  RaiseEvent StyleChanged(Me.Dockable, Me.Moveable, Me.Sizeable)
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Public Property Get Moveable() As Boolean
  Moveable = m_Moveable
End Property

Public Property Let Moveable(ByVal New_Moveable As Boolean)
  If Not New_Moveable Then m_Dockable = False
  
  SetStyles m_Dockable, New_Moveable, Me.Sizeable
  'If m_Moveable <> New_Moveable Then RaiseEvent NewStyle("Moveable", New_Moveable)
  m_Moveable = New_Moveable
  PropertyChanged "Moveable"

  RaiseEvent StyleChanged(Me.Dockable, Me.Moveable, Me.Sizeable)
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Public Property Get Dockable() As Boolean
  Dockable = m_Dockable
End Property

Public Property Let Dockable(ByVal New_Dockable As Boolean)
  If New_Dockable Then
    oldMoveable = Me.Moveable
    oldSizeable = Me.Sizeable
    m_Moveable = True
    m_Sizeable = True
  Else
    m_Sizeable = oldSizeable
    m_Moveable = oldMoveable
  End If
  
  SetStyles New_Dockable, m_Moveable, m_Sizeable
  'If m_Dockable <> New_Dockable Then RaiseEvent NewStyle("Dockable", New_Dockable)
  m_Dockable = New_Dockable
  PropertyChanged "Dockable"
  
  RaiseEvent StyleChanged(Me.Dockable, Me.Moveable, Me.Sizeable)
End Property


Private Sub UserControl_Hide()
  RaiseEvent Hide
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
  m_Sizeable = m_def_Sizeable
  m_Moveable = m_def_Moveable
  m_Dockable = m_def_Dockable
  m_oldMoveable = m_def_Moveable
  m_oldSizeable = m_def_Sizeable
  
  m_Caption = m_def_Caption
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  m_Sizeable = PropBag.ReadProperty("Sizeable", m_def_Sizeable)
  m_Moveable = PropBag.ReadProperty("Moveable", m_def_Moveable)
  m_Dockable = PropBag.ReadProperty("Dockable", m_def_Dockable)
  m_oldMoveable = PropBag.ReadProperty("oldMoveable", m_def_Moveable)
  m_oldSizeable = PropBag.ReadProperty("oldSizeable", m_def_Sizeable)

  UserControl.BackColor = PropBag.ReadProperty("BackColor", &H80&)
  m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
  SendMessage UserControl.hwnd, WM_SETTEXT, 0, ByVal m_Caption
  
  SetStyles m_Dockable, m_Moveable, m_Sizeable
  If Ambient.UserMode Then StartEngine
End Sub

Private Sub UserControl_Show()
  RaiseEvent Show
End Sub

Private Sub UserControl_Terminate()
  StopEngine
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

  Call PropBag.WriteProperty("Sizeable", m_Sizeable, m_def_Sizeable)
  Call PropBag.WriteProperty("Moveable", m_Moveable, m_def_Moveable)
  Call PropBag.WriteProperty("Dockable", m_Dockable, m_def_Dockable)
  Call PropBag.WriteProperty("oldMoveable", m_oldMoveable, m_def_Moveable)
  Call PropBag.WriteProperty("oldSizeable", m_oldSizeable, m_def_Sizeable)
  Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H80&)
  Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
End Sub

Private Property Get WindowStyle() As Long
  WindowStyle = GetWindowLong(UserControl.hwnd, GWL_STYLE)
End Property
Private Property Let WindowStyle(ByVal New_WindowStyle As Long)
Dim iNewWindowStyle As Long
iNewWindowStyle = New_WindowStyle

  SetWindowLong UserControl.hwnd, GWL_STYLE, iNewWindowStyle
  SetWindowPos UserControl.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, _
                                (SWP_NOSIZE Or SWP_NOZORDER Or _
                                SWP_NOMOVE Or SWP_DRAWFRAME)
End Property

Private Property Get WindowExStyle() As Long
  WindowExStyle = GetWindowLong(UserControl.hwnd, GWL_EXSTYLE)
End Property

Private Property Let WindowExStyle(ByVal New_WindowExStyle As Long)
Dim iNewWindowExStyle As Long
iNewWindowExStyle = New_WindowExStyle
  SetWindowLong UserControl.hwnd, GWL_EXSTYLE, iNewWindowExStyle
  SetWindowPos UserControl.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, _
                                (SWP_NOSIZE Or SWP_NOZORDER Or _
                                SWP_NOMOVE Or SWP_DRAWFRAME)
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Private Property Get oldMoveable() As Boolean
  oldMoveable = m_oldMoveable
End Property

Private Property Let oldMoveable(ByVal New_oldMoveable As Boolean)
  m_oldMoveable = New_oldMoveable
  PropertyChanged "oldMoveable"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Private Property Get oldSizeable() As Boolean
  oldSizeable = m_oldSizeable
End Property

Private Property Let oldSizeable(ByVal New_oldSizeable As Boolean)
  m_oldSizeable = New_oldSizeable
  PropertyChanged "oldSizeable"
End Property
Private Sub SetStyles(bDoc As Boolean, bMov As Boolean, bSiz As Boolean)
Dim iOldWindowStyle As Long, iOldWindowExStyle As Long
Dim iNewWindowStyle As Long, iNewWindowExStyle As Long
  iOldWindowStyle = WindowStyle And (Not WS_THICKFRAME) And (Not WS_CAPTION) And (Not WS_SYSMENU)
  iOldWindowExStyle = WindowExStyle And (Not WS_EX_TOOLWINDOW)
  
  iNewWindowStyle = iOldWindowStyle
  iNewWindowExStyle = iOldWindowExStyle
  
  If bDoc Then
    iNewWindowStyle = iOldWindowStyle Or WS_THICKFRAME Or WS_CAPTION Or WS_SYSMENU
    iNewWindowExStyle = iOldWindowExStyle Or WS_EX_TOOLWINDOW
  Else
    If bMov And bSiz Then
      iNewWindowStyle = iOldWindowStyle Or WS_THICKFRAME Or WS_CAPTION
    Else
      If bMov Then iNewWindowStyle = iOldWindowStyle Or WS_CAPTION
      If bSiz Then iNewWindowStyle = iOldWindowStyle Or WS_THICKFRAME
    End If
  End If
  WindowStyle = iNewWindowStyle
  WindowExStyle = iNewWindowExStyle
End Sub


Private Property Let ISubclass_MsgResponse(ByVal RHS As EMsgResponse)
'
End Property

Private Property Get ISubclass_MsgResponse() As EMsgResponse
'
End Property

Private Function ISubclass_WindowProc(ByVal hwnd As Long, ByVal iMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Select Case hwnd
    Case UserControl.hwnd
      Select Case iMsg
        Case WM_NCLBUTTONDOWN
          If (wParam And HTCLOSE) = HTCLOSE Then
            UserControl.Extender.Visible = False
            RaiseEvent CloseButtonClick
          Else
            CallOldWindowProc hwnd, iMsg, wParam, lParam
          End If
          
        Case WM_EXITSIZEMOVE
          If m_MovingUC Then
                  'for usercontrolalignable=true
                  '???? somebody can help me here ???
                  'UserControl.Extender.Align = vbAlignNone
                  '??????????????????
            SetWindowPos UserControl.hwnd, HWND_NOTOPMOST, _
                    m_newUCPos.NewRect.Left, m_newUCPos.NewRect.Top, _
                    m_newUCPos.NewRect.Right - m_newUCPos.NewRect.Left, _
                    m_newUCPos.NewRect.Bottom - m_newUCPos.NewRect.Top, _
                    (SWP_NOZORDER Or _
                     SWP_DRAWFRAME)
            m_MovingUC = False
                  'for usercontrolalignable=true
                  '???? somebody can help me here ???
                  '???????????????????              UserControl.Extender.Align = m_newUCPos.AnchorAt
                  '
              UserControl.MousePointer = 0
          End If
          RaiseEvent ExitSizeMove

        Case WM_MOVING
          If Me.Dockable Then
            m_MovingUC = True
            m_newUCPos = AnchorAt(lParam)
          End If
          
        'case else imsg ...
      End Select 'UserControl.hwnd, iMsg
    '>>> end UserControl.hwnd
    Case m_parentHwnd
      Select Case iMsg
        Case WM_SIZE
          ResizeUC
          RaiseEvent ParentSize
      End Select 'm_parentHwnd,imsg
      
    '>>> end m_parentHwnd
  End Select
End Function

Private Function RCClientToScreen(ByVal newHwnd As Long, rc As RECT) As RECT
Dim ptLT As POINTAPI, ptRB As POINTAPI, newRC As RECT
  ptLT.X = rc.Left
  ptLT.Y = rc.Top
  
  ptRB.X = rc.Right - rc.Left
  ptRB.Y = rc.Bottom - rc.Top
    
  ClientToScreen newHwnd, ptLT
    newRC.Left = ptLT.X
    newRC.Top = ptLT.Y
  
    newRC.Right = ptLT.X + ptRB.X
    newRC.Bottom = ptLT.Y + ptRB.Y
  RCClientToScreen = newRC
End Function

Private Function AnchorAt(ByVal pRectAddress As Long) As tAnchorAt

Dim dif As POINTAPI, newAlignMode As AlignConstants
Dim curPos As POINTAPI, oldCurPos As POINTAPI
Dim rcParent As RECT, newRC As RECT
  dif.X = 90: dif.Y = 90
UserControl.MousePointer = 99
'
  GetCursorPos curPos
  oldCurPos = curPos
  ScreenToClient m_parentHwnd, curPos
  GetClientRect m_parentHwnd, rcParent
  
  With curPos
    If (.Y > dif.Y) And _
        (.Y < rcParent.Bottom - dif.Y) And _
        (.X > dif.X) And _
        (.X < rcParent.Right - dif.X) Then
        'no band
        newAlignMode = vbAlignNone
    ElseIf (.Y <= dif.Y) Then
      'top band
        If (.X < dif.X) Then
          newAlignMode = vbAlignLeft
        ElseIf (.X > rcParent.Right - dif.X) Then
          newAlignMode = vbAlignRight
        Else
          newAlignMode = vbAlignTop
        End If
    ElseIf (.Y >= rcParent.Bottom - dif.Y) Then
      'bottom band
        If (.X < dif.X) Then
          newAlignMode = vbAlignLeft
        ElseIf (.X > rcParent.Right - dif.X) Then
          newAlignMode = vbAlignRight
        Else
          newAlignMode = vbAlignBottom
        End If
    ElseIf (.X <= dif.X) Then
      newAlignMode = vbAlignLeft
    Else
      newAlignMode = vbAlignRight
    End If
  End With
  
  With newRC
    Select Case newAlignMode
      Case vbAlignNone
        .Left = curPos.X - dif.X
        .Top = curPos.Y
        .Right = curPos.X + dif.X
        .Bottom = curPos.Y + 2 * dif.Y
        UserControl.MouseIcon = LoadResPicture("Normal", vbResCursor)
      Case vbAlignTop
        .Left = 0:
        .Top = 0
        .Right = rcParent.Right
        .Bottom = dif.Y
        UserControl.MouseIcon = LoadResPicture("Top", vbResCursor)
        
      Case vbAlignBottom
        .Left = 0
        .Top = rcParent.Bottom - dif.Y
        .Right = rcParent.Right
        .Bottom = rcParent.Bottom
        UserControl.MouseIcon = LoadResPicture("Bottom", vbResCursor)
      Case vbAlignLeft
        .Left = 0
        .Top = 0
        .Right = dif.X
        .Bottom = rcParent.Bottom
        UserControl.MouseIcon = LoadResPicture("Left", vbResCursor)
      Case vbAlignRight
        .Left = rcParent.Right - dif.X
        .Top = 0
        .Right = rcParent.Right
        .Bottom = rcParent.Bottom
        UserControl.MouseIcon = LoadResPicture("Right", vbResCursor)
    End Select
  End With
  
  AnchorAt.AnchorAt = newAlignMode
  AnchorAt.NewRect = newRC

  newRC = RCClientToScreen(m_parentHwnd, newRC)
  

  CopyMemory ByVal pRectAddress, newRC, Len(newRC)

End Function

Public Sub StartEngine()
  StopEngine
  
  AttachMessage Me, UserControl.hwnd, WM_MOVING
  AttachMessage Me, UserControl.hwnd, WM_EXITSIZEMOVE
  
  AttachMessage Me, UserControl.hwnd, WM_NCLBUTTONDOWN
  
  m_parentHwnd = UserControl.Parent.hwnd
  AttachMessage Me, m_parentHwnd, WM_SIZE
  
  
  m_Subclass = True
End Sub
Public Sub StopEngine()

If Not m_Subclass Then Exit Sub
  
  DetachMessage Me, UserControl.hwnd, WM_MOVING
  DetachMessage Me, UserControl.hwnd, WM_EXITSIZEMOVE
  DetachMessage Me, UserControl.hwnd, WM_NCLBUTTONDOWN
  
  DetachMessage Me, m_parentHwnd, WM_SIZE
  
  m_Subclass = False
End Sub


Private Sub ResizeUC()
If m_newUCPos.AnchorAt = vbAlignNone Then Exit Sub

Dim rcUC As RECT, rcPar As RECT, ucSize As POINTAPI
  GetWindowRect UserControl.hwnd, rcUC
      ucSize.X = rcUC.Right - rcUC.Left
      ucSize.Y = rcUC.Bottom - rcUC.Top
  
  GetClientRect m_parentHwnd, rcPar

  Select Case m_newUCPos.AnchorAt
    Case vbAlignTop
      rcUC.Top = 0
      rcUC.Left = 0
      rcUC.Right = rcPar.Right
      rcUC.Bottom = ucSize.Y
      
    Case vbAlignLeft
      rcUC.Top = 0
      rcUC.Left = 0
      rcUC.Right = ucSize.X
      rcUC.Bottom = rcPar.Bottom


    Case vbAlignBottom
      rcUC.Left = 0
      rcUC.Top = rcPar.Bottom - ucSize.Y
      rcUC.Right = rcPar.Right
      rcUC.Bottom = rcPar.Bottom
    
    
    Case vbAlignRight
      rcUC.Left = rcPar.Right - ucSize.X
      rcUC.Top = 0
      rcUC.Right = rcPar.Right
      rcUC.Bottom = rcPar.Bottom
    
    
  End Select
  With rcUC
    SetWindowPos UserControl.hwnd, HWND_NOTOPMOST, .Left, .Top, .Right - .Left, .Bottom - .Top, _
                                (SWP_NOZORDER Or _
                                 SWP_DRAWFRAME)
  End With
End Sub
Private Sub UserControl_DblClick()
  RaiseEvent DblClick
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
  BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
  UserControl.BackColor() = New_BackColor
  PropertyChanged "BackColor"
End Property
Public Function UCHwnd() As Long
  UCHwnd = UserControl.hwnd
End Function


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,""
Public Property Get Caption() As String
  Caption = m_Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
Dim oldCaption As String
  oldCaption = m_Caption
  m_Caption = New_Caption
  SendMessage UserControl.hwnd, WM_SETTEXT, 0, ByVal m_Caption
  If oldCaption <> m_Caption Then
    PropertyChanged "Caption"
  End If
End Property

Private Sub UserControl_Click()
  RaiseEvent Click
End Sub

Private Sub UserControl_HitTest(X As Single, Y As Single, HitResult As Integer)
  RaiseEvent HitTest(X, Y, HitResult)
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
  RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
  RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
  RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub UserControl_Paint()
  RaiseEvent Paint
End Sub

Private Sub UserControl_Resize()
  RaiseEvent Resize
End Sub
Public Function GetAnchorMode() As AlignConstants
  GetAnchorMode = m_newUCPos.AnchorAt
End Function
